const St = imports.gi.St;
const Main = imports.ui.main;
const DBus = imports.dbus;
const Lang = imports.lang;

const GuakeIface = {
  name: 'org.guake.RemoteControl',
  path: '/org/guake/RemoteControl',
  methods: [
    { name: 'add_tab',
      inSignature: 's',
      outSignature: '' },
    { name: 'execute_command',
      inSignature: 's',
      outSignature: '' },
    { name: 'get_selected_tab',
      inSignature: '',
      outSignature: 'i' },
    { name: 'quit',
      inSignature: '',
      outSignature: '' },
    { name: 'rename_current_tab',
      inSignature: 's',
      outSignature: '' },
    { name: 'select_tab',
      inSignature: 'i',
      outSignature: '' },
    { name: 'show_about',
      inSignature: '',
      outSignature: '' },
    { name: 'show_hide',
      inSignature: '',
      outSignature: '' },
    { name: 'show_prefs',
      inSignature: '',
      outSignature: '' }
  ],
  signals: []
};

const GuakeProxy = new Lang.Class({
  Name: 'GuakeProxy',
  _init: function() {
    DBus.session.proxifyObject(this, GuakeIface.name, GuakeIface.path);
  }
});

DBus.proxifyPrototype(GuakeProxy.prototype, GuakeIface);


let guake;

let button;

function init() {

}

function enable() {
  button = new St.Bin({style_class:'panel-button', reactive: true, can_focus: true, x_fill: true, y_fill: true, track_hover: true });

  let shellIcon = new St.Icon({icon_name: 'utilities-terminal', icon_type: St.IconType.SYMBOLIC, style_class: 'system-status-icon'});  

  button.set_child(shellIcon);

  Main.panel._rightBox.insert_child_at_index(button, 0);

  guake = new GuakeProxy();

  button.connect('button-press-event', _toggleGuake);

}

function _toggleGuake() {
  guake.show_hideRemote();
}

function disable() {
  guake = null;

  Main.panel._rightBox.remove_actor(button);
}
